diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index 1d2162d27..83778423c 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -1092,42 +1093,42 @@ public class PacketHandlerClient extends PacketHandler
 	}
     
     @Override
-    public void handleSpawnParticle(PacketAddParticle addParticlePacket)
-    {
-        if (addParticlePacket.isGroup){
-            for (int i = 0; i < addParticlePacket.amount; i++) {
-                mc.renderGlobal.addParticle(addParticlePacket.particleKey,
-                        addParticlePacket.x + rand.nextDouble() * addParticlePacket.randOffX,
-                        addParticlePacket.y + rand.nextDouble() * addParticlePacket.randOffY,
-                        addParticlePacket.z + rand.nextDouble() * addParticlePacket.randOffZ,
-                        addParticlePacket.motionX + rand.nextGaussian() * addParticlePacket.randMotionX,
-                        addParticlePacket.motionY + rand.nextGaussian() * addParticlePacket.randMotionY,
-                        addParticlePacket.motionZ + rand.nextGaussian() * addParticlePacket.randMotionZ,
-                        addParticlePacket.data,
-                        addParticlePacket.maxDistance);
+    public void handleAddParticle(@NotNull PacketAddParticle packetAddParticle)
+    {
+        if (packetAddParticle.isGroup){
+            for (int i = 0; i < packetAddParticle.amount; i++) {
+                mc.renderGlobal.addParticle(packetAddParticle.particleKey,
+                        packetAddParticle.x + rand.nextDouble() * packetAddParticle.randOffX,
+                        packetAddParticle.y + rand.nextDouble() * packetAddParticle.randOffY,
+                        packetAddParticle.z + rand.nextDouble() * packetAddParticle.randOffZ,
+                        packetAddParticle.motionX + rand.nextGaussian() * packetAddParticle.randMotionX,
+                        packetAddParticle.motionY + rand.nextGaussian() * packetAddParticle.randMotionY,
+                        packetAddParticle.motionZ + rand.nextGaussian() * packetAddParticle.randMotionZ,
+                        packetAddParticle.data,
+                        packetAddParticle.maxDistance);
             }
         } else {
-            mc.renderGlobal.addParticle(addParticlePacket.particleKey,
-                    addParticlePacket.x,
-                    addParticlePacket.y,
-                    addParticlePacket.z,
-                    addParticlePacket.motionX,
-                    addParticlePacket.motionY,
-                    addParticlePacket.motionZ,
-                    addParticlePacket.data,
-                    addParticlePacket.maxDistance);
+            mc.renderGlobal.addParticle(packetAddParticle.particleKey,
+                    packetAddParticle.x,
+                    packetAddParticle.y,
+                    packetAddParticle.z,
+                    packetAddParticle.motionX,
+                    packetAddParticle.motionY,
+                    packetAddParticle.motionZ,
+                    packetAddParticle.data,
+                    packetAddParticle.maxDistance);
         }
 
     }
 
     @Override
-    public void handleStatistic(final PacketStatistic statisticPacket)
+    public void handleStatistic(final @NotNull PacketStatistic packetStatistic)
     {
         NamespaceID id;
         try {
-            id = NamespaceID.fromPool(statisticPacket.statID);
+            id = NamespaceID.fromPool(packetStatistic.statID);
         } catch (HardIllegalArgumentException e) {
-            LOGGER.error("Received invalid stat id '{}' from server!", statisticPacket.statID);
+            LOGGER.error("Received invalid stat id '{}' from server!", packetStatistic.statID);
             return;
         }
         final Stat stat = StatList.getStat(id);
@@ -1136,11 +1137,11 @@ public class PacketHandlerClient extends PacketHandler
             return;
         }
         if (stat.clientside) return; // Don't allow server to give client side only stats
-        mc.thePlayer.addStat(stat, statisticPacket.valueChange);
+        mc.thePlayer.addStat(stat, packetStatistic.valueChange);
     }
 
     @Override
-    public void handleEntityPlayerGamemode(PacketPlayerGamemode packet)
+    public void handlePlayerGamemode(@NotNull PacketPlayerGamemode packet)
     {
         Entity entity = getEntityByID(packet.entityId);
         if (entity instanceof Player){
@@ -1149,13 +1150,13 @@ public class PacketHandlerClient extends PacketHandler
     }
 
     @Override
-    public void handleEntityNickname(PacketEntityNickname entityNicknamePacket)
+    public void handleEntityNickname(@NotNull PacketEntityNickname packetEntityNickname)
     {
-        Entity entity = getEntityByID(entityNicknamePacket.entityId);
+        Entity entity = getEntityByID(packetEntityNickname.entityId);
 
         if (entity instanceof Mob) {
-            ((Mob) entity).nickname = StringUtils.substring(entityNicknamePacket.nickname, 0, 32);
-            ((Mob) entity).chatColor = entityNicknamePacket.chatColor;
+            ((Mob) entity).nickname = StringUtils.substring(packetEntityNickname.nickname, 0, 32);
+            ((Mob) entity).chatColor = packetEntityNickname.chatColor;
         }
     }
 
@@ -1166,12 +1167,12 @@ public class PacketHandlerClient extends PacketHandler
     }
     
     @Override
-    public void handleBlockItemSwitch(PacketSetCarriedItem setCarriedItemPacket) {
-        mc.thePlayer.inventory.setCurrentItemIndex(setCarriedItemPacket.id, true);
+    public void handleSetCarriedItem(@NotNull PacketSetCarriedItem packetSetCarriedItem) {
+        mc.thePlayer.inventory.setCurrentItemIndex(packetSetCarriedItem.id, true);
     }
 
     @Override
-    public void handleTileEntityData(PacketTileEntityData packetTileEntityData)
+    public void handleTileEntityData(@NotNull PacketTileEntityData packetTileEntityData)
     {
         Class<?> clazz = TileEntityDispatcher.getClassFromID(packetTileEntityData.tag.getString("id"));
         if (clazz == null) return;
@@ -1192,7 +1193,7 @@ public class PacketHandlerClient extends PacketHandler
     }
 
     @Override
-    public void handleGameRule(PacketGameRule packet) {
+    public void handleGameRule(@NotNull PacketGameRule packet) {
         LevelData levelData = mc.currentWorld.getLevelData();
         if (packet.getGameRules() != null) {
             levelData.getGameRules().setValues(packet.getGameRules());
@@ -1200,12 +1201,12 @@ public class PacketHandlerClient extends PacketHandler
     }
 
     @Override
-    public void handleSyncedRecipe(PacketRecipeSync recipeSyncPacket) {
+    public void handleRecipeSync(@NotNull PacketRecipeSync packetRecipeSync) {
         if(Registries.RECIPES.getAllSerializableRecipes().isEmpty()){
-            LOGGER.info("Receiving {} recipes from server..", recipeSyncPacket.maxRecipes);
+            LOGGER.info("Receiving {} recipes from server..", packetRecipeSync.maxRecipes);
         }
-        DataLoader.loadRecipeFromServer(recipeSyncPacket);
-        if(Registries.RECIPES.getAllSerializableRecipes().size() == recipeSyncPacket.maxRecipes){
+        DataLoader.loadRecipeFromServer(packetRecipeSync);
+        if(Registries.RECIPES.getAllSerializableRecipes().size() == packetRecipeSync.maxRecipes){
             LOGGER.info("All recipes received!");
             Registries.RECIPES.invalidateCaches();
             GuidebookPageSearch.searchField.setText("_");
@@ -1218,26 +1219,26 @@ public class PacketHandlerClient extends PacketHandler
     }
     
     @Override
-    public void handleIds(PacketSyncIDs syncIDsPacket) {
-        if (syncIDsPacket.destinationId == PacketSyncIDs.DESTINATION_SOUND_IDS) {
-            SoundTypes.setSoundIds(syncIDsPacket.mapping);
-        } else if (syncIDsPacket.destinationId == PacketSyncIDs.DESTINATION_ENTITY_IDS) {
-            EntityDispatcher.getInstance().setNumericIds(syncIDsPacket.mapping);
+    public void handleSyncIDs(@NotNull PacketSyncIDs packetSyncIDs) {
+        if (packetSyncIDs.destinationId == PacketSyncIDs.DESTINATION_SOUND_IDS) {
+            SoundTypes.setSoundIds(packetSyncIDs.mapping);
+        } else if (packetSyncIDs.destinationId == PacketSyncIDs.DESTINATION_ENTITY_IDS) {
+            EntityDispatcher.getInstance().setNumericIds(packetSyncIDs.mapping);
         }
     }
     
     @Override
-    public void handleCustomPayload(PacketCustomPayload customPayloadPacket) {
-        if(PacketCustomPayload.CHANNEL_RAINBOW_START.equals(customPayloadPacket.channel)) {
+    public void handleCustomPayload(@NotNull PacketCustomPayload packetCustomPayload) {
+        if(PacketCustomPayload.CHANNEL_RAINBOW_START.equals(packetCustomPayload.channel)) {
 //            System.out.printf("b0:%s b1:%s b2:%s b3:%s\n", packet.data[0], packet.data[1], packet.data[2], packet.data[3]);
-            int rainbowTicks = Byte.toUnsignedInt(customPayloadPacket.data[0]) << 24 | Byte.toUnsignedInt(customPayloadPacket.data[1]) << 16 | Byte.toUnsignedInt(customPayloadPacket.data[2]) << 8 | Byte.toUnsignedInt(customPayloadPacket.data[3]);
+            int rainbowTicks = Byte.toUnsignedInt(packetCustomPayload.data[0]) << 24 | Byte.toUnsignedInt(packetCustomPayload.data[1]) << 16 | Byte.toUnsignedInt(packetCustomPayload.data[2]) << 8 | Byte.toUnsignedInt(packetCustomPayload.data[3]);
 //            System.out.println("Added rainbow with " + rainbowTicks + " ticks");
             worldClientMP.addRainbow(rainbowTicks);
         }
     }
 
     @Override
-    public void handleCommandManagerPacket(PacketCommandManager commandManagerPacket) {
-        GuiElementChatSuggestions.serverSuggestions = commandManagerPacket.suggestions;
+    public void handleCommandManager(@NotNull PacketCommandManager packetCommandManager) {
+        GuiElementChatSuggestions.serverSuggestions = packetCommandManager.suggestions;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java b/game/client/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
index f5d71fcd5..912ee3174 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
@@ -9,6 +9,7 @@ import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.PacketDisconnect;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketServerIcon;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import javax.imageio.ImageIO;
@@ -61,10 +62,10 @@ public class PingPacketHandler
     }
 
     @Override
-    public void handleKickDisconnect(PacketDisconnect packet) {
-        if (packet.reason.startsWith("§1"))
+    public void handleDisconnect(@NotNull PacketDisconnect packetDisconnect) {
+        if (packetDisconnect.reason.startsWith("§1"))
         {
-            String[] serverInfo = packet.reason.split("\0");
+            String[] serverInfo = packetDisconnect.reason.split("\0");
             server.isUp = true;
             server.protocolVersion = parseIntWithDefault(serverInfo[1], -1);
             server.version = serverInfo[2];
@@ -91,7 +92,7 @@ public class PingPacketHandler
     }
 
     @Override
-    public void handleServerIconPacket(PacketServerIcon packetServerIcon) {
+    public void handleServerIcon(@NotNull PacketServerIcon packetServerIcon) {
         try {
             server.queuedIcon = ImageIO.read(new ByteArrayInputStream(packetServerIcon.image));
         } catch (IOException e) {
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index d27ea97f6..2aba8d3e4 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -93,14 +93,14 @@ public class PlayerControllerMP extends PlayerController {
 	@Override
 	public void attack(@NotNull Player entityplayer, @NotNull Entity entity) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new PacketInteract(entityplayer.id, entity.id, PacketInteract.ACTION_ATTACK));
+		netHandler.addToSendQueue(new PacketEntityInteract(entityplayer.id, entity.id, PacketEntityInteract.ACTION_ATTACK));
 		entityplayer.attackTargetEntityWithCurrentItem(entity);
 	}
 
 	@Override
 	public boolean interact(Player entityplayer, Entity entity) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new PacketInteract(entityplayer.id, entity.id, PacketInteract.ACTION_INTERACT));
+		netHandler.addToSendQueue(new PacketEntityInteract(entityplayer.id, entity.id, PacketEntityInteract.ACTION_INTERACT));
 		return entityplayer.useCurrentItemOnEntity(entity);
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/FogManager.java b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
index 24587ee2b..10ab8e7ab 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
@@ -5,17 +5,18 @@ import static org.lwjgl.opengl.GL11.*;
 import java.nio.FloatBuffer;
 
 import net.minecraft.client.world.WorldClient;
-import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3fc;
 import org.lwjgl.opengl.NVFogDistance;
 
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
-import net.minecraft.client.option.enums.RenderDistance;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.client.render.colorizer.Colorizers;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.Dimension;
 
@@ -23,7 +24,7 @@ public class FogManager {
     public static final int FOG_MODE_SKY = -1;
     public static final int FOG_MODE_NORMAL = 0;
 
-    public final Minecraft mc;
+    public final @NotNull Minecraft mc;
 
     public float fogRed;
     public float fogGreen;
@@ -32,36 +33,35 @@ public class FogManager {
     public float fogBrightnessOld;
     public float fogBrightness;
 
-    private final FloatBuffer fogColorBuffer = GLAllocation.createDirectFloatBuffer(16);
+    private final @NotNull FloatBuffer fogColorBuffer = GLAllocation.createDirectFloatBuffer(16);
 
-    public FogManager(Minecraft mc) {
+    public FogManager(@NotNull Minecraft mc) {
         this.mc = mc;
     }
 
     public void updateBrightness() {
-        fogBrightnessOld = fogBrightness;
+        this.fogBrightnessOld = this.fogBrightness;
 
-        float fogModifier = mc.currentWorld.getCurrentWeather() != null ? mc.currentWorld.getCurrentWeather().getFogDistanceMultiplier() : 1.0f;
-        fogModifier = (1.0f - ((1.0f - fogModifier) * mc.currentWorld.weatherManager.getWeatherIntensity() * mc.currentWorld.weatherManager.getWeatherPower()));
+        float fogModifier = this.mc.currentWorld.getCurrentWeather() != null ? this.mc.currentWorld.getCurrentWeather().getFogDistanceMultiplier() : 1.0f;
+        fogModifier = (1.0f - ((1.0f - fogModifier) * this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherPower()));
 
-        float brightnessAtCamera = mc.currentWorld.getLightBrightness(MathHelper.floor(mc.activeCamera.getX(1f)), MathHelper.floor(mc.activeCamera.getY(1f)), MathHelper.floor(mc.activeCamera.getZ(1f)));
-        if (mc.fullbright) brightnessAtCamera = 1.0f;
-        float renderDistanceModifier = (((mc.gameSettings.renderDistance.highest - mc.gameSettings.renderDistance.value) * fogModifier) / (float) mc.gameSettings.renderDistance.highest);
+        float brightnessAtCamera = this.mc.currentWorld.getLightBrightness(this.mc.activeCamera.getTilePos());
+        if (this.mc.fullbright) brightnessAtCamera = 1.0f;
+        float renderDistanceModifier = (((this.mc.gameSettings.renderDistance.highest - this.mc.gameSettings.renderDistance.value) * fogModifier) / (float) this.mc.gameSettings.renderDistance.highest);
 
         float newBrightness = brightnessAtCamera * (1.0F - renderDistanceModifier) + renderDistanceModifier;
 
-        fogBrightness += (newBrightness - fogBrightness) * 0.1F;
+        this.fogBrightness += (newBrightness - this.fogBrightness) * 0.1F;
     }
 
-    public void setupFog(int fogMode, float farPlaneDistance, float partialTick)
-    {
-        glFogfv(GL_FOG_COLOR, buffer(fogRed, fogGreen, fogBlue, 0.5F));
+    public void setupFog(int fogMode, float farPlaneDistance, float partialTick) {
+        glFogfv(GL_FOG_COLOR, buffer(this.fogRed, this.fogGreen, this.fogBlue, 0.5F));
         glNormal3f(0.0F, -1F, 0.0F);
         glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        if (!mc.gameSettings.fog.value && fogMode != FOG_MODE_SKY) {
+        if (!this.mc.gameSettings.fog.value && fogMode != FOG_MODE_SKY) {
             glFogi(GL_FOG_MODE, GL_EXP);
             glFogf(GL_FOG_DENSITY, 0.0F);
-            float maxFogDistance = mc.gameSettings.renderDistance.highest * 16;
+            float maxFogDistance = this.mc.gameSettings.renderDistance.highest * 16;
             glFogf(GL_FOG_START, maxFogDistance * 0.25F);
             glFogf(GL_FOG_END, maxFogDistance);
             glEnable(GL_COLOR_MATERIAL);
@@ -69,46 +69,37 @@ public class FogManager {
             return;
         }
 
-        if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.currentWorld, Material.water, partialTick))
-        {
+        if (CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.WATER, partialTick)) {
             glFogi(GL_FOG_MODE, GL_EXP);
             glFogf(GL_FOG_DENSITY, 0.1F);
-        }
-        else if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.currentWorld, Material.lava, partialTick))
-        {
+        } else if (CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.LAVA, partialTick)) {
             glFogi(GL_FOG_MODE, GL_EXP);
             glFogf(GL_FOG_DENSITY, 2.0F);
-        }
-        else
-        {
+        } else {
             float fogDistance = farPlaneDistance;
-            float maxFogDistance = mc.gameSettings.renderDistance.highest * 16;
+            float maxFogDistance = this.mc.gameSettings.renderDistance.highest * 16;
 
-            float fogModifier = mc.currentWorld.getCurrentWeather() != null ? mc.currentWorld.getCurrentWeather().getFogDistanceMultiplier() : 1.0f;
-            fogModifier = (1.0f - ((1.0f - fogModifier) * mc.currentWorld.weatherManager.getWeatherIntensity() * mc.currentWorld.weatherManager.getWeatherPower()));
+            float fogModifier = this.mc.currentWorld.getCurrentWeather() != null ? this.mc.currentWorld.getCurrentWeather().getFogDistanceMultiplier() : 1.0f;
+            fogModifier = (1.0f - ((1.0f - fogModifier) * this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherPower()));
 
             if (fogDistance > maxFogDistance * fogModifier) fogDistance = maxFogDistance * fogModifier;
 
-            if (mc.currentScreen instanceof ScreenPhotoMode)
-            {
-                fogDistance = farPlaneDistance * ((ScreenPhotoMode)mc.currentScreen).getFog(partialTick);
+            if (this.mc.currentScreen instanceof ScreenPhotoMode) {
+                fogDistance = farPlaneDistance * ((ScreenPhotoMode) this.mc.currentScreen).getFog(partialTick);
             }
 
             glFogi(GL_FOG_MODE, GL_LINEAR);
             glFogf(GL_FOG_START, (fogDistance * 0.25F) * fogModifier);
             glFogf(GL_FOG_END, fogDistance);
             glFogf(GL_FOG_DENSITY, 1);
-            if(fogMode == FOG_MODE_SKY)
-            {
+            if (fogMode == FOG_MODE_SKY) {
                 glFogf(GL_FOG_START, 0.0F);
                 glFogf(GL_FOG_END, fogDistance * 0.8F);
             }
-            if(OpenGLHelper.enableSphericalFog)
-            {
+            if (OpenGLHelper.enableSphericalFog) {
                 glFogi(NVFogDistance.GL_FOG_DISTANCE_MODE_NV, NVFogDistance.GL_EYE_RADIAL_NV);
             }
-            if(mc.currentWorld.dimension == Dimension.NETHER)
-            {
+            if (this.mc.currentWorld.dimension == Dimension.NETHER) {
                 glFogf(GL_FOG_START, 0.0F);
             }
         }
@@ -116,47 +107,42 @@ public class FogManager {
         glColorMaterial(GL_FRONT, GL_AMBIENT);
     }
 
-    public void updateFogColor(float partialTick)
-    {
-        WorldClient world = mc.currentWorld;
+    public void updateFogColor(float partialTick) {
+        WorldClient world = this.mc.currentWorld;
 
-        float renderDistanceScale = 1.0F / (float)((mc.gameSettings.renderDistance.highest + 8) - mc.gameSettings.renderDistance.value);
+        float renderDistanceScale = 1.0F / (float) ((this.mc.gameSettings.renderDistance.highest + 8) - this.mc.gameSettings.renderDistance.value);
         renderDistanceScale = 1.0F - (float) Math.pow(renderDistanceScale, 0.25D);
 
-        Vec3 skyColor = world.getSkyColor(mc.activeCamera, partialTick);
-        float rSky = (float)skyColor.x;
-        float gSky = (float)skyColor.y;
-        float bSky = (float)skyColor.z;
-
-        Vec3 worldColor = world.getFogColor(mc.activeCamera, partialTick);
-        fogRed = (float)worldColor.x;
-        fogGreen = (float)worldColor.y;
-        fogBlue = (float)worldColor.z;
-
-        fogRed += (rSky - fogRed) * renderDistanceScale;
-        fogGreen += (gSky - fogGreen) * renderDistanceScale;
-        fogBlue += (bSky - fogBlue) * renderDistanceScale;
-
-        if (world.getCurrentWeather() != null)
-        {
-            float[] out = world.getCurrentWeather().modifyFogColor(fogRed, fogGreen, fogBlue, world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower());
-            fogRed = out[0];
-            fogGreen = out[1];
-            fogBlue = out[2];
+        Vector3fc skyColor = world.getSkyColor(this.mc.activeCamera, partialTick);
+        float rSky = skyColor.x();
+        float gSky = skyColor.y();
+        float bSky = skyColor.z();
+
+        Vector3fc worldColor = world.getFogColor(this.mc.activeCamera, partialTick);
+        this.fogRed = worldColor.x();
+        this.fogGreen = worldColor.y();
+        this.fogBlue = worldColor.z();
+
+        this.fogRed += (rSky - this.fogRed) * renderDistanceScale;
+        this.fogGreen += (gSky - this.fogGreen) * renderDistanceScale;
+        this.fogBlue += (bSky - this.fogBlue) * renderDistanceScale;
+
+        if (world.getCurrentWeather() != null) {
+            float[] out = world.getCurrentWeather().modifyFogColor(this.fogRed, this.fogGreen, this.fogBlue, world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower());
+            this.fogRed = out[0];
+            this.fogGreen = out[1];
+            this.fogBlue = out[2];
         }
-        if(CameraUtil.isUnderLiquid(mc.activeCamera, world, Material.water, partialTick))
-        {
-            fogRed = 0.02F;
-            fogGreen = 0.02F;
-            fogBlue = 0.2F;
-            if(mc.gameSettings.biomeWater.value)
-            {
-                int x = MathHelper.floor(mc.activeCamera.getX(partialTick));
-                int z = MathHelper.floor(mc.activeCamera.getZ(partialTick));
-                double temp = world.getBlockTemperature(x, z);
-                double humid = world.getBlockHumidity(x, z);
+        if (CameraUtil.isUnderLiquid(this.mc.activeCamera, world, Materials.WATER, partialTick)) {
+            this.fogRed = 0.02F;
+            this.fogGreen = 0.02F;
+            this.fogBlue = 0.2F;
+            if (this.mc.gameSettings.biomeWater.value) {
+                TilePos cameraTile = this.mc.activeCamera.getTilePos();
+                double temp = world.getBlockTemperature(cameraTile);
+                double humid = world.getBlockHumidity(cameraTile);
                 int waterColor = Colorizers.water.getColor(temp, humid);
-                
+
                 float red = ((waterColor >> 16) & 0xFF) / 255F;
                 float green = ((waterColor >> 8) & 0xFF) / 255F;
                 float blue = (waterColor & 0xFF) / 255F;
@@ -165,36 +151,33 @@ public class FogManager {
                 green = MathHelper.clamp(green, 0, 1);
                 blue = MathHelper.clamp(blue, 0, 1);
 
-                fogRed = red * 0.5f;
-                fogGreen = green * 0.5f;
-                fogBlue = blue * 0.5f;
+                this.fogRed = red * 0.5f;
+                this.fogGreen = green * 0.5f;
+                this.fogBlue = blue * 0.5f;
             }
-        }
-        else if(CameraUtil.isUnderLiquid(mc.activeCamera, world, Material.lava, partialTick))
-        {
-            fogRed = 0.6F;
-            fogGreen = 0.1F;
-            fogBlue = 0.0F;
+        } else if (CameraUtil.isUnderLiquid(this.mc.activeCamera, world, Materials.LAVA, partialTick)) {
+            this.fogRed = 0.6F;
+            this.fogGreen = 0.1F;
+            this.fogBlue = 0.0F;
         }
 
-        float brightness = fogBrightnessOld + (fogBrightness - fogBrightnessOld) * partialTick;
-        fogRed *= brightness;
-        fogGreen *= brightness;
-        fogBlue *= brightness;
-        if (mc.currentScreen instanceof ScreenModelViewer) {
-            float[] color = ((ScreenModelViewer) mc.currentScreen).getBackgroundFogColor();
-            fogRed = color[0];
-            fogGreen = color[1];
-            fogBlue = color[2];
+        float brightness = this.fogBrightnessOld + (this.fogBrightness - this.fogBrightnessOld) * partialTick;
+        this.fogRed *= brightness;
+        this.fogGreen *= brightness;
+        this.fogBlue *= brightness;
+        if (this.mc.currentScreen instanceof ScreenModelViewer screenModelViewer) {
+            float[] color = screenModelViewer.getBackgroundFogColor();
+            this.fogRed = color[0];
+            this.fogGreen = color[1];
+            this.fogBlue = color[2];
         }
-        glClearColor(fogRed, fogGreen, fogBlue, 0.0F);
+        glClearColor(this.fogRed, this.fogGreen, this.fogBlue, 0.0F);
     }
 
-    private FloatBuffer buffer(float r, float g, float b, float a)
-    {
-        fogColorBuffer.clear();
-        fogColorBuffer.put(r).put(g).put(b).put(a);
-        fogColorBuffer.flip();
-        return fogColorBuffer;
+    private @NotNull FloatBuffer buffer(float r, float g, float b, float a) {
+        this.fogColorBuffer.clear();
+        this.fogColorBuffer.put(r).put(g).put(b).put(a);
+        this.fogColorBuffer.flip();
+        return this.fogColorBuffer;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
index 1f503d8d5..d37c4bc33 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render;
 import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.render.entity.MobRendererPlayer;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.material.Materials;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -14,7 +15,6 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
@@ -202,7 +202,7 @@ public class ItemRenderer
 			}
 
 		}
-		if(mc.thePlayer.isUnderLiquid(Material.water)) {
+		if(mc.thePlayer.isUnderLiquid(Materials.WATER)) {
             mc.textureManager.loadTexture("/assets/minecraft/textures/misc/water.png").bind();
 			renderWarpedTextureOverlay(partialTicks);
 		}
